local RSA = LibStub("AceAddon-3.0"):GetAddon("RSA")
local L = LibStub("AceLocale-3.0"):GetLocale("RSA")

local MODNAME = "Reminders"
local RSA_R = RSA:NewModule(MODNAME)


-- Using Mapster to help me modulise everything!
--[[
local options
local function getOptions()
	if not options then
		options = {
			type = "group",
			name = "Instance Maps",
			arg = MODNAME,
			get = optGetter,
			set = optSetter,
			args = {
				intro = {
					order = 1,
					type = "description",
					name = "The Instance Maps module allows you to view the Instance and Battleground Maps provided by the game without being in the instance yourself.",
				},
				enabled = {
					order = 2,
					type = "toggle",
					name = "Enable Instance Maps",
					get = function() return Mapster:GetModuleEnabled(MODNAME) end,
					set = function(info, value) Mapster:SetModuleEnabled(MODNAME, value) end,
				},
			},
		}
	end

	return options
end]]--



function RSA_R:OnInitialize()

	--self:SetEnabledState(RSA:GetModuleEnabled(MODNAME))
	--RSA:RegisterModuleOptions(MODNAME, getOptions, "Instance Maps")


end



function RSA_R:OnEnable()
end






local function Print_Self(message) -- Send a message to your default chat window.
	_G.ChatFrame1:AddMessage("|cFFFF75B3RSA:|r " .. format(message))
end

local function Print_Self_RW(message) -- Send a message locally to the raid warning frame. Only visible to the user.
	local RWColor = {r=1, g=1, b=1}
	RaidNotice_AddMessage(RaidWarningFrame, "|cFFFF75B3RSA:|r " .. format(message), RWColor)
end





----------------------------------
---- Spell Reminder Functions ----
----------------------------------

--[[ Spell Reminder ]]--
local ReminderTimeElapsed = 0.0
RSA_Reminder = CreateFrame("Frame", "RSA:R")
local function Reminder(self, elapsed)
	if RSA.db.profile.General.Class == "DEATHKNIGHT" then -- Check Class, Set the Spell we're reminding about.
		ReminderSpell = RSA.db.profile.DeathKnight.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "DRUID" then
		ReminderSpell = RSA.db.profile.Druid.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "HUNTER" then
		ReminderSpell = RSA.db.profile.Hunter.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "MAGE" then
		ReminderSpell = RSA.db.profile.Mage.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "PALADIN" then
		ReminderSpell = RSA.db.profile.Paladin.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "PRIEST" then
		ReminderSpell = RSA.db.profile.Priest.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "ROGUE" then
		ReminderSpell = RSA.db.profile.Rogue.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "SHAMAN" then
		ReminderSpell = RSA.db.profile.Shaman.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "WARLOCK" then
		ReminderSpell = RSA.db.profile.Warlock.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "WARRIOR" then
		ReminderSpell = RSA.db.profile.Warrior.Reminders.SpellName
	end
	if ReminderSpell == "" then return end
	if RSA.db.profile.Reminders.DisableInPvP == true and UnitIsPVP("player") then return end
	ReminderTimeElapsed = ReminderTimeElapsed + elapsed
	if ReminderTimeElapsed < RSA.db.profile.Reminders.RemindInterval then return end
	ReminderTimeElapsed = ReminderTimeElapsed - floor(ReminderTimeElapsed)
	local name = UnitBuff("player", ReminderSpell)
	if name == ReminderSpell then
		RSA_Reminder:SetScript("OnUpdate", nil)
	end
	if UnitIsDeadOrGhost("player") == 1 then return end
	if RSA.db.profile.Reminders.EnableInSpec1 == true then
		if GetActiveTalentGroup("player") == 1 then
			if RSA.db.profile.Reminders.RemindChannels.Chat == true then
				Print_Self(ReminderSpell .. " is Missing!")
			end
			if RSA.db.profile.Reminders.RemindChannels.RaidWarn == true then
				Print_Self_RW(ReminderSpell .. " is Missing!")
			end
		end
	end
	if RSA.db.profile.Reminders.EnableInSpec2 == true then
		if GetActiveTalentGroup("player") == 2 then
			if RSA.db.profile.Reminders.RemindChannels.Chat == true then
				Print_Self(ReminderSpell .. " is Missing!")
			end
			if RSA.db.profile.Reminders.RemindChannels.RaidWarn == true then
				Print_Self_RW(ReminderSpell .. " is Missing!")
			end
		end
	end
end

RSA_Monitor = CreateFrame("Frame", "RSA:M")
local MonitorTimeElapsed = 0.0
local function Monitor(self, elapsed)
	MonitorTimeElapsed = MonitorTimeElapsed + elapsed
	if MonitorTimeElapsed < RSA.db.profile.Reminders.CheckInterval then return end
	MonitorTimeElapsed = MonitorTimeElapsed - floor(MonitorTimeElapsed)
	if RSA.db.profile.General.Class == "DEATHKNIGHT" then -- Check Class, Set the Spell we're reminding about.
		ReminderSpell = RSA.db.profile.DeathKnight.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "DRUID" then
		ReminderSpell = RSA.db.profile.Druid.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "HUNTER" then
		ReminderSpell = RSA.db.profile.Hunter.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "MAGE" then
		ReminderSpell = RSA.db.profile.Mage.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "PALADIN" then
		ReminderSpell = RSA.db.profile.Paladin.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "PRIEST" then
		ReminderSpell = RSA.db.profile.Priest.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "ROGUE" then
		ReminderSpell = RSA.db.profile.Rogue.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "SHAMAN" then
		ReminderSpell = RSA.db.profile.Shaman.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "WARLOCK" then
		ReminderSpell = RSA.db.profile.Warlock.Reminders.SpellName
	elseif RSA.db.profile.General.Class == "WARRIOR" then
		ReminderSpell = RSA.db.profile.Warrior.Reminders.SpellName
	end
	if ReminderSpell == "" then return end
	local name = UnitBuff("player", ReminderSpell)
	if name ~= ReminderSpell then
		RSA_Reminder:SetScript("OnUpdate", Reminder)
	end
end
RSA_Monitor:SetScript("OnUpdate", Monitor)